* Program Name: prncfg.prg 
* Author: Pat Y. Boens 
* Copyright (c) 1995 by FoxPro Xbase FOCUS
*Ŀ
* Created: 16 February 1995 at 11:41                                
*                                                                   
* ................................................................. 
* Revision number : 1.0 Last Revised : 16 February 1995 at 11:41    
* Description     : Original Creation. Fully commented.             
*                                                                   
*                   Display all installed printers                  
*                   Allows settings                                 
*                                                                   
* Special note    : feel free to use this code in your real life    
*                   apps.                                           
* ................................................................. 
*                                                                   
*                       Ŀ                      
*Ĵ FoxPro Xbase Focus 
*                        

#define GRAY                    RGB( 128,128,128,128,128,128 )
#define LIGHT_GRAY              RGB( 192,192,192,192,192,192 )
#define GRAY_LIGHT              RGB( 128,128,128,192,192,192 )
#define WHITE                   RGB( 255,255,255,255,255,255 )
#define BLACK                   RGB( 0,0,0,0,0,0 )
#define BACKGROUND              RGB( ,,,192,192,192 )
#define BLACK_ON_WHITE          RGB( ,,,255,255,255 )

SET LIBRARY TO FOCUS                   && Load FOCUS library

=FNT_name( "Arial" )                   && Global font setting
=FNT_size( 8 )                         && Global font setting

DO PrnDialog                           && Run example

SET LIBRARY TO                         && Unload FOCUS library

PROCEDURE PrnDialog
    PRIVATE aPrns                      && Array of installed printers
    PRIVATE aPrnNames                  && Array of printer names
    PRIVATE aDrvs                      && Array of printer drivers

    PRIVATE aGets                      && 3D effects around GETs

    PRIVATE m.cPrnName                 && Current printer name
    PRIVATE m.cPrnPort                 && Current printer port

    PRIVATE m.nWhich                   && Which printer ?

    PRIVATE m.nCancel                  && Cancel button
    PRIVATE m.nClose                   && Close button
    PRIVATE m.nSettings                && Settings button
    PRIVATE m.nHelp                    && Help button
    PRIVATE nDefault                   && Set default printer button

    PRIVATE m.cPrns                    && All printers from WIN.INI
    PRIVATE m.OldSep                   && Old separator
    PRIVATE nTokens                    && Number of tokens
    PRIVATE i                          && Token subscript

    IF ( RDLEVEL() == 5 )              && Are we already too deep ?
        =TooManyReads()                && ... yes display an error message
        RETU                           &&     and get back where we came from
    ENDIF

    m.nWhich    = 1

    m.nCancel   = 1                    && Initialization of Cancel button
    m.nClose    = 1                    && Initialization of Close button
    m.nSettings = 1                    && Initialization of Settings button
    m.nHelp     = 1                    && Initialization of Help button
    nDefault    = 1                    && Initialization of Set default button

    =PRN_capa()                        && Printer settings

    m.cPrnName = PRN_name()            && Current printer name
    m.cPrnPort = PRN_port()            && Printer port
    m.cPrns    = FIL_wsecti("devices") && All installed printers

    m.OldSep   = STR_setsep( ";" )     && New separator to extract printers
    m.nTokens  = STR_numtok( m.cPrns ) && Number of installed printers

    DIMENSION aPrns[m.nTokens]         && Dimension of installed printers
    DIMENSION aPrnNames[m.nTokens]     && Dimension of printer names
    DIMENSION aDrvs[m.nTokens]         && Dimension of printer drivers

    FOR i = 1 TO m.nTokens             && Extract each token now !

        && Place printer name in appropriate array
        aPrnNames[i] = STR_ntoken( i,m.cPrns )

        && Place printer driver in appropriate array
        aDrvs[i]  = FIL_wreain( "devices",aPrnNames[i] )

        && Complete printer name + driver name + "on" + printer port
        aPrns[i] = aPrnNames[i]                                  + ;
                   " (" + STR_strtok( 1,aDrvs[i],"," ) + ") on " + ;
                   STR_strtok( 2,aDrvs[i],"," )
    NEXT

    =STR_setsep( m.OldSep )            && Reset old separator of FOCUS

    DIMENSION aGets[1,4]               && Array for 3D effects

    && Defining main window
    DEFINE WINDOW wPrinters        ;
        AT 0.000, 0.000            ;
        SIZE 19.40,100.00          ;
        TITLE "Printers"           ;
        FONT FNT_name(),FNT_size() ;
        FLOAT                      ;
        NOCLOSE                    ;
        NOMINIMIZE                 ;
        SYSTEM                     ;
        COLOR BACKGROUND

    && Activate window but don't show it
    ACTIVATE WINDOW wPrinters NOSHOW

    && Move window to the center of the screen
    MOVE WINDOW wPrinters CENTER

    && Borders
    =Grave( 01.00,02.00,03.50,78.00,"Default printer"    )
    =Grave( 04.50,02.00,18.00,78.00,"Installed printers" )

    @ 01.80,04.00 SAY m.cPrnName + " on " + m.cPrnPort

    aGets[1,1] = 5.5                   && Values to display 3D effect
    aGets[1,2] = 4.2                   && Values to display 3D effect
    aGets[1,3] = 09.4                  && Values to display 3D effect
    aGets[1,4] = 72                    && Values to display 3D effect

    && Display the 3D effect now !
    DO NiceGet WITH aGets,FNT_name(),FNT_size()

    @ 18.20,02.00 SAY "Setting the default printer will affect all other Windows applications"

    && GETs section -----------------------------------------------------
    @ 05.50,04.00 GET m.nWhich                           ;
                  PICTURE "@&N"                          ;
                  FROM aPrns                             ;
                  SIZE 09.30,71.80                       ;
                  COLOR BLACK_ON_WHITE,BLACK_ON_WHITE    ;
                  MESSAGE "Select the new default printer"

    @ 15.50,17.00 GET m.nDefault                         ;
                  PICTURE "@*HN \!\<Set default printer" ;
                  SIZE 02.00,45.00,00.50                 ;
                  STYLE "B"                              ;
                  VALID SetDefPrn( m.nWhich )            ;
                  MESSAGE "Set the default printer"             

    @ 01.00,81.00 GET m.nCancel                          ;
                  PICTURE "@*HNT \<Cancel"               ;
                  SIZE 01.80,16.00,00.30                 ;
                  STYLE "B"                              ;
                  MESSAGE "Abandon"

    @ 03.10,81.00 GET m.nClose                           ;
                  PICTURE "@*HNT \\Close"                ;
                  SIZE 01.80,16.00,00.30                 ;
                  STYLE "B"                              ;
                  MESSAGE "Close window and keep new settings"

    @ 05.20,81.00 GET m.nSettings                        ;
                  PICTURE "@*HN Settings"                ;
                  SIZE 01.80,16.00,00.30                 ;
                  STYLE "B"                              ;
                  VALID SeeSettings( m.cPrnName )        ;
                  MESSAGE "View current default printer settings and change them"

    @ 07.30,81.00 GET m.nHelp                            ;
                  PICTURE "@*VN Help"                    ;
                  SIZE 01.80,16.00,00.30                 ;
                  STYLE "B"                              ;
                  VALID ShowHelp()                       ;
                  MESSAGE "Self explanatory. Isn't it ?"

    && Show the window now !
    ACTIVATE WINDOW wPrinters

    && Issue the READ statement
    READ CYCLE MODAL

    && Discard the window now !
    RELEASE WINDOW wPrinters

RETURN

*----------------------------------------------------------------------------*

FUNCTION ShowHelp

    WAIT WINDOW "Not implemented" NOWAIT

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION SetDefPrn                     && Set default Printer
    PARAMETER m.cPrinter               && Which printer ?

    && Write default printer in WIN.INI
    =FIL_wwriin( "windows", ;
                 "device" , ;
                 aPrnNames[m.nWhich] + "," + aDrvs[m.nWhich] )

    =PRN_capa()                        && Get current printer settings

    m.cPrnName = PRN_name()            && Printer name
    m.cPrnPort = PRN_port()            && Port sur lequel elle est installe

    && Clear line (odd isn't it ?)
    @ 01.80,04.00 SAY REPLICATE("B",40) COLOR RGB(192,192,192,192,192,192),RGB(192,192,192,192,192,192)

    && Now that the line is cleared, display the new default printer name
    @ 01.80,04.00 SAY m.cPrnName + " on "  + m.cPrnPort

    SHOW GET m.nCancel DISABLE         && Refresh GET
    SHOW GET m.nClose  ENABLE          && Refresh GET

RETURN ( .T. )

*----------------------------------------------------------------------------*

FUNCTION SeeSettings
    PARAMETER m.cPrnName

    PRIVATE m.nReso                    && Printer resolution
    PRIVATE m.nPaperS                  && Paper size
    PRIVATE m.nBin                     && Paper bin
    PRIVATE m.nOrient                  && Printer orientation
    PRIVATE m.nCopies                  && Number of copies
    PRIVATE m.nSetup                   && Setup button
    PRIVATE m.nCancel                  && Cancel button

    PRIVATE aSizes                     && Array of paper sizes
    PRIVATE aBins                      && Array of paper bins
    PRIVATE aReso                      && Array of printer resolutions

    IF ( RDLEVEL() == 5 )              && Are we already too deep ?
        =TooManyReads()                && ... yes display an error message
        RETU ( .T. )                   &&     and get back where we came from
    ENDIF

    m.nSetup  = 1                      && Initialization of Setup button
    m.nCancel = 1                      && Initialization of Cancel button

    DIMENSION aSizes[41]               && Dimension of paper sizes
    DIMENSION aBins[14]                && Dimension of paper bins
    DIMENSION aReso[3]                 && Dimension of printer resolutions

    =PRN_capa()                        && Get current printer settings

    && Create a window whose title is the current default printer
    DEFINE WINDOW wSettings        ;
        AT 00.00, 00.00            ;
        SIZE 17.00,85.00           ;
        TITLE ( m.cPrnName )       ;
        FONT FNT_name(),FNT_size() ;
        FLOAT                      ;
        NOCLOSE                    ;
        NOMINIMIZE                 ;
        SYSTEM                     ;
        COLOR BACKGROUND

    && Activate window but don't show it yet !
    ACTIVATE WINDOW wSettings NOSHOW

    && Move window to the center of the screen
    MOVE WINDOW wSettings CENTER

    =PrepSizes()                       && Prepare paper sizes array
    =PrepBins()                        && Prepare paper bins array
    =PrepReso()                        && Prepare printer resolutions array

    && Border (General)
    =Grave( 01.00,02.00,WROWS()-1,59.50,"General" )

    && Border (Controls)
    =Grave( 01.00,60.50,WROWS()-1,WCOLS()-2,"Controls" )

    && Border (Orientation)
    =Grave( 08.00,04.00,13.00,40.00,"Orientation" )

    @ 02.00,04.00 SAY "Resolution"
    @ 03.50,04.00 SAY "Paper size"
    @ 05.00,04.00 SAY "Paper bin"
    @ 14.00,04.00 SAY "Copies"

    m.nOrient = PRN_orient()           && Printer orientation
    m.nPaperS = PRN_paperS()           && Paper size
    m.nBin    = PRN_source()           && Paper bin source
    m.nCopies = PRN_copies()           && Number of copies
    m.nReso   = 1                      && Does not work properly

    =ShowOrient()                      && Display a bitmap according to orientation

    && GETs section -----------------------------------------------------
    @ 01.85,18.00 GET m.nReso                           ;
                  PICTURE "@^"                          ;
                  FROM aReso                            ;
                  SIZE 01.50,40.00

    @ 03.35,18.00 GET m.nPaperS                         ;
                  PICTURE "@^"                          ;
                  FROM aSizes                           ;
                  SIZE 01.50,40.00

    @ 04.85,18.00 GET m.nBin                            ;
                  PICTURE "@^"                          ;
                  FROM aBins                            ;
                  SIZE 01.50,40.00

    @ 09.00,14.00 GET m.nOrient                         ;
                  SIZE 01.31,15.00,00.00                ;
                  PICTURE "@*RVN Portrait;Landscape"    ;
                  STYLE "BT"                            ;
                  COLOR ,,,,,,,,BACKGROUND,BACKGROUND

    @ 14.00,12.00 GET m.nCopies                         ;
                  SPINNER 01.00,01.00,99.00             ;
                  PICTURE "@K"                          ;
                  SIZE 01.00,10.00                      ;
                  COLOR SCHEME 19
    
    @ 02.50,64.00 GET m.nCancel                         ;
                  PICTURE "@*HNT \<Cancel"              ;
                  SIZE 01.80,16.00,00.30                ;
                  STYLE "B"

    @ 04.60,64.00 GET m.nSetup                          ;
                  PICTURE "@*HN \!\<Setup"              ;
                  SIZE 01.80,16.00,00.30                ;
                  STYLE "B"                             ;
                  VALID Configure()

    && Show window now !
    ACTIVATE WINDOW wSettings

    && Read, please
    READ CYCLE MODAL

    && Discard window
    RELEASE WINDOW wSettings

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE Configure                    && Configure default printer

    =PRN_copies( m.nCopies )           && New number of copies (GET value)
    =PRN_orient( m.nOrient )           && New orientation (GET value)
    =PRN_paperS( m.nPaperS )           && New paper size (GET value)
    =PRN_source( m.nBin    )           && New paper source (GET value)

    IF ( PRN_set() != 0 )              && Setup printer NOW !
        ?? CHR(7)                      && ... If setup not OK ... BEEP
    ENDIF

    =PRN_capa()                        && Get real settings

    m.nOrient = PRN_orient()           && Printer orientation
    m.nPaperS = PRN_paperS()           && Paper size
    m.nBin    = PRN_source()           && Paper bin source
    m.nCopies = PRN_copies()           && Number of copies

    SHOW GET m.nOrient                 && Refresh GET
    SHOW GET m.nPaperS                 && Refresh GET
    SHOW GET m.nBin                    && Refresh GET
    SHOW GET m.nCopies                 && Refresh GET

    =ShowOrient()                      && Display bitmap according to orientation

RETURN ( .T. )

*----------------------------------------------------------------------*

PROCEDURE NiceGet                      && 3D effect
    PARAMETERS aGets,m.cFont,nSize,cStyle

    *-- Ŀ
    *--  This procedure seems to be a little tricky and in fact it IS 
    *--                                                               
    *--  PURPOSE : draws different boxes around a GET in order to     
    *--            create 3D effects.                                 
    *-- 

    PRIVATE m.i
    PRIVATE m.nRatio
    PRIVATE m.nPixH

    PRIVATE m.nTop
    PRIVATE m.nLeft
    PRIVATE m.nBottom
    PRIVATE m.nRight

    m.nRatio = 1 / FONTMETRIC( 1,m.cFont,m.nSize )
    m.nPixH  = 1 / FONTMETRIC( 2,m.cFont,m.nSize )

    m.i = 0

    DO WHILE ( m.i < ALEN( aGets,1 ) )

        m.i = m.i + 1

        m.nTop    = aGets[i,1] - 2 * m.nRatio
        m.nLeft   = aGets[i,2] - 0.400
        m.nBottom = aGets[i,1] + aGets[i,3] + m.nRatio
        m.nRight  = aGets[i,2] + aGets[i,4] + 0.100

        IF ( m.nBottom > WROWS() )
            m.nBottom = WROWS() - 0.500
        ENDIF

        IF ( nRight > WCOLS() )
            m.nRight = WCOLS() - 0.500
        ENDIF

        @ m.nTop   ,m.nLeft  TO                                ;
          m.nBottom,m.nLeft PEN 1,8 COLOR GRAY_LIGHT

        @ m.nTop   ,m.nLeft  TO                                ;
          m.nTop,m.nRight PEN 1,8 STYLE "1" COLOR GRAY_LIGHT

        @ m.nTop   ,m.nRight TO                                ;
          m.nBottom+nRatio,nRight PEN 1,8 COLOR RGB(255,255,255,192,192,192)

        @ m.nBottom,m.nLeft  TO                                ;
          m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR RGB(255,255,255,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nLeft      + m.nPixH      ;
            PEN 1,8                   ;
            COLOR RGB(0,0,0,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nTop       + m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            STYLE "1"                 ;
            COLOR RGB(0,0,0,192,192,192)

        @ m.nTop       + m.nRatio   , ;
          m.nRight     - m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            COLOR LIGHT_GRAY

        @ m.nBottom    - m.nRatio   , ;
          m.nLeft      + m.nPixH TO   ;
          m.nBottom    - m.nRatio   , ;
          m.nRight     - m.nPixH      ;
            PEN 1, 8                  ;
            STYLE "1"                 ;
            COLOR LIGHT_GRAY

    ENDDO

RETURN

*----------------------------------------------------------------------*

FUNCTION WIN_grave
    PARAMETERS m.t,m.l,m.b,m.r

    *-- Ŀ
    *--  PURPOSE : Draw a carved line in a specific region.           
    *-- 

    PRIVATE m.nH
    PRIVATE m.nW
    PRIVATE m.cFont
    PRIVATE m.nSize

    m.cFont = WFONT( 1 )
    m.nSize = WFONT( 2 )

    m.nH    = 1 / FONTMETRIC( 1,m.cFont,m.nSize )
    m.nW    = 1 / FONTMETRIC( 6,m.cFont,m.nSize )

    @ m.t     ,m.l      TO m.b     ,m.r      PEN 0 COLOR GRAY
    @ m.t+m.nH,m.l+m.nW TO m.b+m.nH,m.r+m.nW PEN 0 COLOR WHITE

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION PrepSizes

    aSizes[01] = "Letter 8 1/2 x 11 in"
    aSizes[02] = "Letter Small 8 1/2 x 11 in"
    aSizes[03] = "Tabloid 11 x 17 in"
    aSizes[04] = "Ledger 17 x 11 in"
    aSizes[05] = "Legal 8 1/2 x 14 in"
    aSizes[06] = "Statement 5 1/2 x 8 1/2 in"
    aSizes[07] = "Executive 7 1/4 x 10 1/2 in"
    aSizes[08] = "A3 297 x 420 mm"
    aSizes[09] = "A4 210 x 297 mm"
    aSizes[10] = "A4 Small 210 x 297 mm"
    aSizes[11] = "A5 148 x 210 mm"
    aSizes[12] = "B4 250 x 354"
    aSizes[13] = "B5 182 x 257 mm"
    aSizes[14] = "Folio 8 1/2 x 13 in"
    aSizes[15] = "Quarto 215 x 275 mm"
    aSizes[16] = "10x14 in"
    aSizes[17] = "11x17 in"
    aSizes[18] = "Note 8 1/2 x 11 in"
    aSizes[19] = "Envelope #9 3 7/8 x 8 7/8"
    aSizes[20] = "Envelope #10 4 1/8 x 9 1/2"
    aSizes[21] = "Envelope #11 4 1/2 x 10 3/8"
    aSizes[22] = "Envelope #12 4 \276 x 11"
    aSizes[23] = "Envelope #14 5 x 11 1/2"
    aSizes[24] = "C size sheet"
    aSizes[25] = "DEFINE WINDOW size sheet"
    aSizes[26] = "E size sheet"
    aSizes[27] = "Envelope DL 110 x 220mm"
    aSizes[28] = "Envelope C5 162 x 229 mm"
    aSizes[29] = "Envelope C3  324 x 458 mm"
    aSizes[30] = "Envelope C4  229 x 324 mm"
    aSizes[31] = "Envelope C6  114 x 162 mm"
    aSizes[32] = "Envelope C65 114 x 229 mm"
    aSizes[33] = "Envelope B4  250 x 353 mm"
    aSizes[34] = "Envelope B5  176 x 250 mm"
    aSizes[35] = "Envelope B6  176 x 125 mm"
    aSizes[36] = "Envelope 110 x 230 mm"
    aSizes[37] = "Envelope Monarch 3.875 x 7.5 in"
    aSizes[38] = "6 3/4 Envelope 3 5/8 x 6 1/2 in"
    aSizes[39] = "US Std Fanfold 14 7/8 x 11 in"
    aSizes[40] = "German Std Fanfold 8 1/2 x 12 in"
    aSizes[41] = "German Legal Fanfold 8 1/2 x 13 in"

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION PrepBins

    aBins[01]  = "Upper"
    aBins[02]  = "Lower"
    aBins[03]  = "Middle"
    aBins[04]  = "Manual"
    aBins[05]  = "Envelope"
    aBins[06]  = "Envelope manual"
    aBins[07]  = "Auto"
    aBins[08]  = "Tractor"
    aBins[09]  = "Small format"
    aBins[10]  = "Large format"
    aBins[11]  = "Large capacity"
    aBins[12]  = ""
    aBins[13]  = ""
    aBins[14]  = "Cassette"

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION PrepReso

    aReso[01]  = "300"
    aReso[02]  = "150"
    aReso[03]  = "75"

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION Grave
    PARAMETERS m.t,m.l,m.b,m.r,m.cTitle

    =WIN_grave( m.t,m.l,m.b,m.r )
    @ m.t - 00.50,m.l + 02.00 SAY m.cTitle  STYLE "B"

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION ShowOrient

    IF ( m.nOrient == 1 )              && Portait mode
        @ 09.00,06.00 SAY "portrait.bmp" BITMAP
    ELSE
        @ 09.00,06.00 SAY "landscap.bmp" BITMAP
    ENDIF

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION TooManyReads

    WAIT WINDOW "Too many READs in effect. Sorry !" TIMEOUT 2

RETURN ( .T. )
